#version 330 core

in vec2 texcoords;

uniform sampler2D color_texture;
uniform bool horizontal;

uniform float gauss[5] = float[] (0.227027, 0.1945946, 0.1216216, 0.054054, 0.016216);

layout(location = 0) out vec4 fragColor;

void main() 
{
	vec2 texelSize = 1.0 / textureSize(color_texture, 0);
	vec4 color = textureLod(color_texture, texcoords, 1) * gauss[0];
	
	for(int i = 1; i < 5; i++)
	{
		vec2 offset;	
		if(horizontal)			
			offset = vec2(texelSize.x * i, 0);					
		else 
			offset = vec2(0, texelSize.y * i);
				
		color += textureLod(color_texture, texcoords + offset, 1) * gauss[i];
		color += textureLod(color_texture, texcoords - offset, 1) * gauss[i];
	}
	
	fragColor = color;	
}