#version 330 core
int LFSR_Rand_Gen(int n ) 
{ 
	n = (n << 13) ^ n;
	return (n * (n*n*15731+789221) + 1376312589) & 0x7fffffff;
} 
float LFSR_Rand_Gen_f(int n ) 
{ 
	return float(LFSR_Rand_Gen(n)); 
} 
float noise3f(vec3 p ) 
{ 
	ivec3 ip = ivec3(floor(p)); 
	vec3 u = fract(p); 
	u = u*u*(3.0-2.0*u); 
	int n = ip.x + ip.y*57 + ip.z*113; 
	float res = mix(mix(mix(LFSR_Rand_Gen_f(n+(0+57*0+113*0)), LFSR_Rand_Gen_f(n+(1+57*0+113*0)),u.x), mix(LFSR_Rand_Gen_f(n+(0+57*1+113*0)), LFSR_Rand_Gen_f(n+(1+57*1+113*0)),u.x),u.y), mix(mix(LFSR_Rand_Gen_f(n+(0+57*0+113*1)), LFSR_Rand_Gen_f(n+(1+57*0+113*1)),u.x), mix(LFSR_Rand_Gen_f(n+(0+57*1+113*1)), LFSR_Rand_Gen_f(n+(1+57*1+113*1)),u.x),u.y),u.z); 
	return 1.0 - res*(1.0/1073741824.0); 
} 


#define ty(x,y) (pow(.5+sin((x)*y*6.2831)/2.0,2.0)-.5) 
#define t2(x,y)  ty(y + 2.0*ty(x+2.0*noise3f(vec3(cos((x)/3.0)+x,y,(x)*.1)),.3),.7) 
#define tx(x,y,a,d)  ((t2(x, y) * (a - x) * (d - y) +  t2(x - a, y) * x * (d - y) + t2(x, y - d) * (a - x) * y +  t2(x - a, y - d) * x * y) / (a * d)) 

vec4 fx(vec2 x) 
{ 
	float a=0.0,d=32.0; // Modified FBM functions to generate a blob texture 
	for(;d>=1.0;d/=2.0) 
		a += abs(tx(x.x*2.0*d, x.y*2.0*d, 2.0*d, 2.0*d)/(2.0*d));
 	return vec4(a*2.0); 
}

in vec2 texUV;
in vec3 pos;

uniform sampler2D color_texture;
uniform vec4 color;
uniform bool hasColorTexture;

uniform sampler2D shadowMap;


layout(location = 0) out vec4 fragColor;

void main()
{
	vec3 xi = fx(texUV).xyz; 
	vec4 col = vec4(0.0,0.0,0.0,0.0);	

	if(hasColorTexture)
	{
		col = texture(color_texture, texUV);
	}else{
		col = color;
		col.a = fragColor.a;
	}
	col.a = 1.0;

	//vec3 rho = (col / 255).xyz;
	vec3 rho = col.xyz;
	rho = (vec3(1)-rho)*col.a;
	
	bvec3 bools = greaterThan(xi, rho);

	//vec3 depthV = vec3(gl_FragCoord.z);
	//vec3 depthV = vec3(texture(shadowMap, texUV));
float z = gl_FragCoord.z;
float near = 0.01;
float far = 100.0;

float value = (2.0 * near) / (far + near - z * (far - near));

vec3 depthV = vec3(value);

	
	//fragColor = vec4(depthV,1.0); // Temporary fix due to compiler issus
	fragColor = vec4(max(depthV, vec3(bools)),1.0);
//fragColor = vec4(1.0,0.5,0.5,1.0);

}