#version 330 core
#extension GL_ARB_geometry_shader4: enable

layout (triangles) in;

//3 vertices per tri, output 6 tris (1 for each cm-face)
layout (triangle_strip, max_Vertices = 18) out;

uniform mat4 cm_matrices[6];

out vec4 worldPosition;

void main() 
{
	// Create Triangle for each cubemap face
    for(gl_Layer = 0; gl_Layer < 6; gl_Layer++)
	{
        for(int index = 0; index < 3; index ++)
		{
			worldPosition = gl_in[index].gl_Position;
			gl_Position = cm_matrices[gl_Layer] * worldPosition;
			EmitVertex();
        }
		EndPrimitive();
	}
}

