#version 330 core

in vec2 texcoords;

uniform sampler2D color_texture;
uniform int blurSize = 4;

layout(location = 0) out vec4 fragColor;

void main()
{
    vec2 texelSize = 1.0 / vec2(textureSize(color_texture, 0));
    
	fragColor = vec4(0.0);
   
    vec2 hlim = vec2(float(blurSize) * 0.5 + 0.5);
    
	for(int x = 0; x < blurSize; x++)
	{
        for(int y = 0; y < blurSize; y++)
		{
		vec2 offset = (hlim + vec2(float(x), float(y))) * texelSize;
		fragColor+= texture(color_texture, texcoords + offset);
        }
	}

	fragColor /= blurSize * blurSize;
}